// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FUserPinInfo.h"
#include "ISCW_UK2Node.h"
#include <memory>
#include <string>
#include <vector>

using std::shared_ptr;
using std::vector;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UK2Node_EditablePinBase : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_EditablePinBase() = default;

		virtual void ClearUserDefinedPins() const = 0;

		virtual bool GetIsEditable() const = 0;

		virtual vector<ISCW_FUserPinInfoPtr> GetUserDefinedPins() const = 0;

		virtual void SetIsEditable(bool InIsEditable) = 0;
	};

	using ISCW_UK2Node_EditablePinBaseConstPtr = shared_ptr<const ISCW_UK2Node_EditablePinBase>;
	using ISCW_UK2Node_EditablePinBasePtr = shared_ptr<ISCW_UK2Node_EditablePinBase>;
} // namespace Sourcify